__CASM__			equ	0
CCASM_ONLY			equ	0
CCASM_5BIT_NEG_BUG		equ	0
CCASM_PCR_NOOFFSET_BUG		equ	0

;
; Regression test for code generation. The output generated by CASM is
; compared against that of CCASM by Roger Taylor. 
;

	org	$0000
	setdp	$ff


tst_bit	macro	op
	{op}	a,0,1,$80
	{op}	a,1,1,$90
	{op}	a,2,1,$a0
	{op}	a,3,1,$b0
	{op}	a,4,1,$c0
	{op}	a,5,1,$d0
	{op}	a,6,1,$e0
	{op}	a,7,1,$f0
	{op}	a,1,0,$80
	{op}	a,1,1,$90
	{op}	a,1,2,$a0
	{op}	a,1,3,$b0
	{op}	a,1,4,$c0
	{op}	a,1,5,$d0
	{op}	a,1,6,$e0
	{op}	a,1,7,$f0
	{op}	a,7,7,$ff
	{op}	cc,3,5,$ff
	{op}	b,6,3,$94
	endm

	
tst_idx	macro	op
	{op}	,x
	{op}	,y
	{op}	,s
	{op}	,u
	{op}	,w
	
	if	CCASM_PCR_NOOFFSET_BUG
	{op}	,pc
	{op}	,pcr
	endif
	
	{op}	,x+
	{op}	,y+
	{op}	,s+
	{op}	,u+
	{op}	,-x
	{op}	,-y
	{op}	,-s
	{op}	,-u
	{op}	,x++
	{op}	,y++
	{op}	,s++
	{op}	,u++
	{op}	,w++
	{op}	,--x
	{op}	,--y
	{op}	,--s
	{op}	,--u
	{op}	,--w
	
	{op}	a,x
	{op}	b,x
	{op}	d,x
	{op}	e,x
	{op}	f,x
	{op}	w,x
	{op}	0,x
	{op}	0,y
	{op}	0,s
	{op}	0,u
	{op}	0,w
	{op}	0,pc
	{op}	0,pcr
	{op}	15,x
	{op}	15,y
	{op}	15,s
	{op}	15,u
	{op}	15,w
	{op}	15,pc
	{op}	15,pcr
	
	{op}	-16,x
	{op}	-16,y
	{op}	-16,s
	{op}	-16,u
	if	CCASM_5BIT_NEG_BUG
	{op}	-16,w
	{op}	-16,pc
	{op}	-16,pcr
	endif
	
	{op}	127,x
	{op}	127,y
	{op}	127,s
	{op}	127,u
	{op}	127,w
	{op}	127,pc
	{op}	127,pcr
	{op}	-128,x
	{op}	-128,y
	{op}	-128,s
	{op}	-128,u
	{op}	-128,w
	{op}	-128,pc
	{op}	-128,pcr
	{op}	32767,x
	{op}	32767,y
	{op}	32767,s
	{op}	32767,u
	{op}	32767,w
	{op}	32767,pc
	{op}	32767,pcr
	{op}	-32768,x
	{op}	-32768,y
	{op}	-32768,s
	{op}	-32768,u
	{op}	-32768,w
	{op}	-32768,pc
	{op}	-32768,pcr
	{op}	[$0000]
	{op}	[$0080]
	{op}	[$4000]
	{op}	[0,x]
	{op}	[0,y]
	{op}	[0,s]
	{op}	[0,u]
	{op}	[0,w]
	{op}	[0,pc]
	{op}	[0,pcr]
	{op}	[,x]
	{op}	[,y]
	{op}	[,s]
	{op}	[,u]
	{op}	[,w]
	
	if	CCASM_PCR_NOOFFSET_BUG
	{op}	[,pc]
	{op}	[,pcr]
	endif
	
	{op}	[,x++]
	{op}	[,y++]
	{op}	[,s++]
	{op}	[,u++]
	{op}	[,w++]
	{op}	[,--x]
	{op}	[,--y]
	{op}	[,--s]
	{op}	[,--u]
	{op}	[,--w]
	{op}	[15,x]
	{op}	[15,y]
	{op}	[15,s]
	{op}	[15,u]
	{op}	[15,w]
	{op}	[15,pc]
	{op}	[15,pcr]

	if	CCASM_5BIT_NEG_BUG
	{op}	[-16,x]
	{op}	[-16,y]
	{op}	[-16,s]
	{op}	[-16,u]
	{op}	[-16,w]
	{op}	[-16,pc]
	{op}	[-16,pcr]
	endif
	
	{op}	[127,x]
	{op}	[127,y]
	{op}	[127,s]
	{op}	[127,u]
	{op}	[127,w]
	{op}	[127,pc]
	{op}	[127,pcr]
	{op}	[-128,x]
	{op}	[-128,y]
	{op}	[-128,s]
	{op}	[-128,u]
	{op}	[-128,w]
	{op}	[-128,pc]
	{op}	[-128,pcr]
	{op}	[32767,x]
	{op}	[32767,y]
	{op}	[32767,s]
	{op}	[32767,u]
	{op}	[32767,w]
	{op}	[32767,pc]
	{op}	[32767,pcr]
	{op}	[-32768,x]
	{op}	[-32768,y]
	{op}	[-32768,s]
	{op}	[-32768,u]
	{op}	[-32768,w]
	{op}	[-32768,pc]
	{op}	[-32768,pcr]
	endm
	
	
tst_idx2	macro	op
	{op}	-128,s
	{op}	-127,s
	{op}	-126,s
	{op}	-125,s
	{op}	-124,s
	{op}	-123,s
	{op}	-122,s
	{op}	-121,s
	{op}	-120,s
	{op}	-119,s
	{op}	-118,s
	{op}	-117,s
	{op}	-116,s
	{op}	-115,s
	{op}	-114,s
	{op}	-113,s
	{op}	-112,s
	{op}	-111,s
	{op}	-110,s
	{op}	-109,s
	{op}	-108,s
	{op}	-107,s
	{op}	-106,s
	{op}	-105,s
	{op}	-104,s
	{op}	-103,s
	{op}	-102,s
	{op}	-101,s
	{op}	-100,s
	{op}	-99,s
	{op}	-98,s
	{op}	-97,s
	{op}	-96,s
	{op}	-95,s
	{op}	-94,s
	{op}	-93,s
	{op}	-92,s
	{op}	-91,s
	{op}	-90,s
	{op}	-89,s
	{op}	-88,s
	{op}	-87,s
	{op}	-86,s
	{op}	-85,s
	{op}	-84,s
	{op}	-83,s
	{op}	-82,s
	{op}	-81,s
	{op}	-80,s
	{op}	-79,s
	{op}	-78,s
	{op}	-77,s
	{op}	-76,s
	{op}	-75,s
	{op}	-74,s
	{op}	-73,s
	{op}	-72,s
	{op}	-71,s
	{op}	-70,s
	{op}	-69,s
	{op}	-68,s
	{op}	-67,s
	{op}	-66,s
	{op}	-65,s
	{op}	-64,s
	{op}	-63,s
	{op}	-62,s
	{op}	-61,s
	{op}	-60,s
	{op}	-59,s
	{op}	-58,s
	{op}	-57,s
	{op}	-56,s
	{op}	-55,s
	{op}	-54,s
	{op}	-53,s
	{op}	-52,s
	{op}	-51,s
	{op}	-50,s
	{op}	-49,s
	{op}	-48,s
	{op}	-47,s
	{op}	-46,s
	{op}	-45,s
	{op}	-44,s
	{op}	-43,s
	{op}	-42,s
	{op}	-41,s
	{op}	-40,s
	{op}	-39,s
	{op}	-38,s
	{op}	-37,s
	{op}	-36,s
	{op}	-35,s
	{op}	-34,s
	{op}	-33,s
	{op}	-32,s
	{op}	-31,s
	{op}	-30,s
	{op}	-29,s
	{op}	-28,s
	{op}	-27,s
	{op}	-26,s
	{op}	-25,s
	{op}	-24,s
	{op}	-23,s
	{op}	-22,s
	{op}	-21,s
	{op}	-20,s
	{op}	-19,s
	{op}	-18,s
	{op}	-17,s
	
	if	CCASM_5BIT_NEG_BUG
	{op}	-16,s
	endif
	
	{op}	-15,s
	{op}	-14,s
	{op}	-13,s
	{op}	-12,s
	{op}	-11,s
	{op}	-10,s
	{op}	-9,s
	{op}	-8,s
	{op}	-7,s
	{op}	-6,s
	{op}	-5,s
	{op}	-4,s
	{op}	-3,s
	{op}	-2,s
	{op}	-1,s
	{op}	0,s
	{op}	1,s
	{op}	2,s
	{op}	3,s
	{op}	4,s
	{op}	5,s
	{op}	6,s
	{op}	7,s
	{op}	8,s
	{op}	9,s
	{op}	10,s
	{op}	11,s
	{op}	12,s
	{op}	13,s
	{op}	14,s
	{op}	15,s
	{op}	16,s
	{op}	17,s
	{op}	18,s
	{op}	19,s
	{op}	20,s
	{op}	21,s
	{op}	22,s
	{op}	23,s
	{op}	24,s
	{op}	25,s
	{op}	26,s
	{op}	27,s
	{op}	28,s
	{op}	29,s
	{op}	30,s
	{op}	31,s
	{op}	32,s
	{op}	33,s
	{op}	34,s
	{op}	35,s
	{op}	36,s
	{op}	37,s
	{op}	38,s
	{op}	39,s
	{op}	40,s
	{op}	41,s
	{op}	42,s
	{op}	43,s
	{op}	44,s
	{op}	45,s
	{op}	46,s
	{op}	47,s
	{op}	48,s
	{op}	49,s
	{op}	50,s
	{op}	51,s
	{op}	52,s
	{op}	53,s
	{op}	54,s
	{op}	55,s
	{op}	56,s
	{op}	57,s
	{op}	58,s
	{op}	59,s
	{op}	60,s
	{op}	61,s
	{op}	62,s
	{op}	63,s
	{op}	64,s
	{op}	65,s
	{op}	66,s
	{op}	67,s
	{op}	68,s
	{op}	69,s
	{op}	70,s
	{op}	71,s
	{op}	72,s
	{op}	73,s
	{op}	74,s
	{op}	75,s
	{op}	76,s
	{op}	77,s
	{op}	78,s
	{op}	79,s
	{op}	80,s
	{op}	81,s
	{op}	82,s
	{op}	83,s
	{op}	84,s
	{op}	85,s
	{op}	86,s
	{op}	87,s
	{op}	88,s
	{op}	89,s
	{op}	90,s
	{op}	91,s
	{op}	92,s
	{op}	93,s
	{op}	94,s
	{op}	95,s
	{op}	96,s
	{op}	97,s
	{op}	98,s
	{op}	99,s
	{op}	100,s
	{op}	101,s
	{op}	102,s
	{op}	103,s
	{op}	104,s
	{op}	105,s
	{op}	106,s
	{op}	107,s
	{op}	108,s
	{op}	109,s
	{op}	110,s
	{op}	111,s
	{op}	112,s
	{op}	113,s
	{op}	114,s
	{op}	115,s
	{op}	116,s
	{op}	117,s
	{op}	118,s
	{op}	119,s
	{op}	120,s
	{op}	121,s
	{op}	122,s
	{op}	123,s
	{op}	124,s
	{op}	125,s
	{op}	126,s
	{op}	127,s
	endm


tst_mop	macro	op,val
	{op}	{val};$ff
	{op}	{val};$3333
	{op}	{val};,x
	{op}	{val};,y
	{op}	{val};,s
	{op}	{val};,u
	{op}	{val};,w
	{op}	{val};,x+
	{op}	{val};,y+
	{op}	{val};,s+
	{op}	{val};,u+
	{op}	{val};,x++
	{op}	{val};,y++
	{op}	{val};,s++
	{op}	{val};,u++
	{op}	{val};,w++
	{op}	{val};15,x
	{op}	{val};15,y
	{op}	{val};15,s
	{op}	{val};15,u
	{op}	{val};15,w
	
	if	CCASM_5BIT_NEG_BUG
	{op}	{val};-16,x
	{op}	{val};-16,y
	{op}	{val};-16,s
	{op}	{val};-16,u
	{op}	{val};-16,w
	endif
	
	{op}	{val};127,x
	{op}	{val};127,y
	{op}	{val};127,s
	{op}	{val};127,u
	{op}	{val};127,w
	{op}	{val};-128,x
	{op}	{val};-128,y
	{op}	{val};-128,s
	{op}	{val};-128,u
	{op}	{val};-128,w
	{op}	{val};32767,x
	{op}	{val};32767,y
	{op}	{val};32767,s
	{op}	{val};32767,u
	{op}	{val};32767,w
	{op}	{val};-32768,x
	{op}	{val};-32768,y
	{op}	{val};-32768,s
	{op}	{val};-32768,u
	{op}	{val};-32768,w
	{op}	{val};[$0000]
	{op}	{val};[$0080]
	{op}	{val};[$4000]
	{op}	{val};[,x]
	{op}	{val};[,y]
	{op}	{val};[,s]
	{op}	{val};[,u]
	{op}	{val};[,w]
	{op}	{val};[,x++]
	{op}	{val};[,y++]
	{op}	{val};[,s++]
	{op}	{val};[,u++]
	{op}	{val};[,w++]
	{op}	{val};[15,x]
	{op}	{val};[15,y]
	{op}	{val};[15,s]
	{op}	{val};[15,u]
	{op}	{val};[15,w]

	if	CCASM_5BIT_NEG_BUG
	{op}	{val};[-16,x]
	{op}	{val};[-16,y]
	{op}	{val};[-16,s]
	{op}	{val};[-16,u]
	{op}	{val};[-16,w]
	endif
	
	{op}	{val};[127,x]
	{op}	{val};[127,y]
	{op}	{val};[127,s]
	{op}	{val};[127,u]
	{op}	{val};[127,w]
	{op}	{val};[-128,x]
	{op}	{val};[-128,y]
	{op}	{val};[-128,s]
	{op}	{val};[-128,u]
	{op}	{val};[-128,w]
	{op}	{val};[32767,x]
	{op}	{val};[32767,y]
	{op}	{val};[32767,s]
	{op}	{val};[32767,u]
	{op}	{val};[32767,w]
	{op}	{val};[-32768,x]
	{op}	{val};[-32768,y]
	{op}	{val};[-32768,s]
	{op}	{val};[-32768,u]
	{op}	{val};[-32768,w]
	{op}	{val};,x
	{op}	{val};,y
	{op}	{val};,s
	{op}	{val};,u
	{op}	{val};,w
	endm
	
test0	macro	op
	{op}	$ff01	* Test direct mode
	{op}	$3333	* Test extended mode
	tst_idx	{op}
	endm


test1	macro	op
	{op}	#$01	* Test immediate mode
	test0	{op}
	endm
	

tst_rr	macro	op
	{op}	a,b
	{op}	x,d
	{op}	v,x
	{op}	s,u
	endm
	
tst_pp	macro	op,reg
	{op}	cc,a,b,dp,x,y,{reg},pc
	{op}	cc,d,dp,x,y,{reg},pc
	{op}	cc
	{op}	a
	{op}	b
	{op}	d
	{op}	dp
	{op}	x
	{op}	y
	{op}	{reg}
	{op}	pc
	endm
	
test3	macro	op

@a	nop
	nop
	{op}	@a
	{op}	@b
	nop
@b	nop

	endm
	
	tst_pp	pshs,u
	
	if	__CASM__=1&CCASM_ONLY=1
	tst_idx2	adca
	tst_idx2	lda
	tst_idx2	ldx
	tst_idx2	ldq
	endif

	abx
	test1	adca
	test1	adcb
	test1	adcd
	test1	adda
	test1	addb
	test1	addd
	test1	adde
	test1	addf
	test1	addw
	test1	anda
	test1	andb
	andcc	#$ff
	test1	andd
	test0	asl
	asla
	aslb
	asld
	test0	asr
	asra
	asrb
	asrd
	test3	bcc
	test3	bcs
	test3	beq
	test3	bge
	test3	bgt
	test3	bhi
	test3	bhs
	test1	bita
	test1	bitb
	test1	bitd
	bitmd	#$11
	test3	ble
	test3	blo
	test3	bls
	test3	blt
	test3	bmi
	test3	bne
	test3	bpl
	test3	bra
	test3	brn
	test3	bsr
	test3	bvc
	test3	bvs
	test0	clr
	clra
	clrb
	clrd
	clre
	clrf
	clrw
	test1	cmpa
	test1	cmpb
	test1	cmpd
	test1	cmpe
	test1	cmpf
	test1	cmps
	test1	cmpu
	test1	cmpw
	test1	cmpx
	test1	cmpy
	test0	com
	coma
	comb
	comd
	come
	comf
	comw
	cwai	#$44
	daa
	test0	dec
	deca
	decb
	decd
	dece
	decf
	decw
	test1	divd
	test1	divq
	test1	eora
	test1	eorb
	test1	eord
	test0	inc
	inca
	incb
	incd
	ince
	incf
	incw
	test0	jmp
	test0	jsr
	test3	lbcc
	test3	lbcs
	test3	lbeq
	test3	lbge
	test3	lbgt
	test3	lbhi
	test3	lbhs
	test3	lble
	test3	lblo
	test3	lbls
	test3	lblt
	test3	lbmi
	test3	lbne
	test3	lbpl
	test3	lbra
	test3	lbrn
	test3	lbsr
	test3	lbvc
	test3	lbvs
	test1	lda
	test1	ldb
	test1	ldd
	test1	lde
	test1	ldf
	ldmd	#$ff
	test1	ldq
	test1	lds
	test1	ldu
	test1	ldy
	test1	ldx
	tst_idx	leas
	tst_idx	leau
	tst_idx	leay
	tst_idx	leax
	test0	lsl
	lsla
	lslb
	test0	lsr
	lsra
	lsrb
	lsrd
	lsrw
	mul
	test1	muld
	test0	neg
	nega
	negb
	negd
	nop
	test0	ora
	test0	orb
	orcc	#$ff
	test0	ord
	tst_pp	pshs,u
	tst_pp	puls,u
	tst_pp	pshu,s
	tst_pp	pulu,s
	pshsw
	pshuw
	pulsw
	puluw
	test0	rol
	rola
	rolb
	rold
	rolw
	test0	ror
	rora
	rorb
	rord
	rorw
	rti
	rts
	test1	sbca
	test1	sbcb
	test1	sbcd
	sex
	sexw
	test0	sta
	test0	stb
	test0	std
	test0	ste
	test0	stf
	test0	stw
	test0	sts
	test0	stu
	test0	stx
	test0	sty
	test1	suba
	test1	subb
	test1	subd
	test1	sube
	test1	subf
	test1	subw
	swi
	swi2
	swi3
	sync
	test0	tst
	tsta
	tstb
	tstd
	tste
	tstf
	tstw
	tst_rr	tfr
	tst_rr	exg
	tst_rr	adcr
	tst_rr	addr
	tst_rr	andr
	tst_rr	orr
	tst_rr	cmpr
	tst_rr	eorr
	tst_rr	sbcr
	tst_rr	subr
	tst_mop	aim,#$44
	tst_mop	eim,#$55
	tst_mop	oim,#$dd
	tst_mop	tim,#$88
	tst_bit	ldbt
	tst_bit	stbt
	tst_bit	band
	tst_bit	biand
	tst_bit	bor
	tst_bit	bior
	tst_bit	beor
	tst_bit	bieor
*
* Test memory transfers with TFM. CCASM does not appear to support the TFM
* operand so we conditional it out
*
	if	__CASM__=1&CCASM_ONLY=1
	tfm	x+,y+
	tfm	x-,y-
	tfm	x,y+
	tfm	x+,y
	endif
*
	copy	x,y
	copy-	x,y
	imp	x,y
	exp	x,y
	tfrp	x,y
	tfrm	x,y
	tfrs	x,y
	tfrr	x,y



color	struct
red	rmb	1
green	rmb	1
blue	rmb	1
	endstruct



	lda	,x
	lda	0,x
	lda	color.red,x
	ldb	$1111+color.red
	ldb	$1111+color.green
	ldb	$1111+color.blue
	
	if	__CASM__=1&CCASM_ONLY=1
	ldb	#sizeof(color)
	endif
	
	ldb	#sizeof{color}
	

